#include <iomanip>
#include <sstream>
using namespace std;

#include "Time.h"


// class function implementations

Time::Time() {
    hour = 12;
    minute = 0;
}

Time::Time(int hr) {
    hour = hr;
    minute = 0;
}

Time::Time(int hr, int min) {
    hour = hr;
    minute = min;
}

void Time::setHour(int hr) {
    hour = hr;           // hour is a member var
}
void Time::setMinute(int min) {
    minute = min;        // minute is a member var
}
int Time::getHour() const {
    return hour;
}
int Time::getMinute() const {
    return minute;
}

void Time::addHour() {  // a private member func
    if (hour == 12)
        hour = 1;
    else
        hour++;
}

void Time::addMinute()
{
    if (minute == 59) {
        minute = 0;
        addHour();   // call to private member func
    } else
        minute++;
}

string Time::display() const {
    // returns time in string formatted to hh:mm
    ostringstream sout;
    sout.fill('0');
    sout << hour << ":" << setw(2) << minute;
    return sout.str();
}

int Time::operator- (Time right) {
    return  (hour % 12) * 60 + minute -
    ((right.hour % 12) * 60 + right.minute);
}

Time Time::operator+ (Time right) { //Note: 12%12 = 0
    int totalMin = (hour%12)*60 + minute +
                   (right.hour%12)*60 + right.minute;
    int h = totalMin / 60;  //integer division, total hours
    h = h%12;               //keep it between 0 and 11
    if (h==0) h = 12;       //convert 0:xx to 12:xx
    Time result(h, totalMin % 60);  //create new time obj
    return result;
}

bool Time::operator== (Time right) {
    return (hour==right.hour && minute==right.minute);
}

bool Time::operator< (Time right) {
    if (hour == right.hour)
        return (minute < right.minute);
    return ( hour < right.hour);
}
